def printWithNoTrace(cmd) {
steps.sh (script: '#!/bin/sh -e\n'+ cmd,returnStdout: true)
}

KUBE_PATH="/usr/local/bin"
properties([
    parameters([
        gitParameter(branch: '*',
                     branchFilter: 'origin/(.*)',
                     defaultValue: 'main',
                     description: '',
                     name: 'BRANCH',
                     quickFilterEnabled: false,
                     selectedValue: 'NONE',
                     sortMode: 'NONE',
                     tagFilter: '*',
                     type: 'PT_BRANCH')
    ])
])
node {
     currentBuild.displayName = "api-finansys-image@version-${params.BRANCH}"
    stage("Docker Login"){
        withCredentials([[$class: 'UsernamePasswordMultiBinding', credentialsId:'harbor', usernameVariable: 'USERNAME', passwordVariable: 'PASSWORD']]) {
            printWithNoTrace('docker login registry.lab.amrcloud.local -u $USERNAME -p $PASSWORD');
        }
    }

    stage("GitCheckout"){
        git branch: "${params.BRANCH}", credentialsId: 'gitlab-remote', url: 'https://gitlab.com/renan.marcos.amorim/api-finansys.git'
    }
    
    stage("Build Iamge - api-finansys@version-${params.BRANCH}"){
        script{
            sh "docker build -t registry.lab.amrcloud.local/api/api-finansys:${params.BRANCH} . --no-cache"
        }
    }
    stage("Docker Push - api-finansys@version-${params.BRANCH}"){
        script{
            sh "docker push registry.lab.amrcloud.local/api/api-finansys:${params.BRANCH}"
        }
    }

    stage("Clean Node images"){
        script{
            sh "docker system prune -f"
        }
    }
}
